Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jet.util
Interface RandomInputable

All Superinterfaces:
  java.io.DataInput, jet.util.RandomAccessable

    public interface RandomInputable

extends jet.util.RandomAccessable, java.io.DataInput

The `RandomInputable` interface provides for reading bytes from a binary stream and skipping over bytes of the input, discarding the skipped bytes.

Method Summary
`void` | `close()` Closes this RandomInputable and releases any system resources associated with the input.
`int` | `read()` Reads the next byte of data from the RandomInputable.
`int` | `read(byte[] b)` Reads some number of bytes from the RandomInputable and stores them into the buffer array `b`.
`int` | `read(byte[] b, int off, int len)` Reads at most `len` bytes of data from the RandomInputable into an array of bytes.
`void` | `saveTo(java.lang.String filename)` Saves all contents of RandomInputable into a destination file.
`int` | `skipBytes(int n)` Attempts to skip over `n` bytes of the input, discarding the skipped bytes.

Methods inherited from interface jet.util.RandomAccessable
`getPosition, length, seek`

Methods inherited from interface java.io.DataInput
`readBoolean, readByte, readChar, readDouble, readFloat, readFully, readFully, readInt, readLine, readLong, readShort, readUnsignedByte, readUnsignedShort, readUTF`

Method Detail

### close

    void close()
               throws java.io.IOException

  Closes this RandomInputable and releases any system resources associated with the input.

  Throws:
    `java.io.IOException` - if an I/O error occurs.

### read

    int read()
             throws java.io.IOException

  Reads the next byte of data from the RandomInputable. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream is reached, the value `-1` will be returned. This method is blocked until the input data is available, the end of the stream is detected, or an exception is thrown.

  Returns:
    the next byte of data, or `-1` if the end of the stream is reached.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### read

    int read(byte[] b,
             int off,
             int len)
             throws java.io.IOException

  Reads at most `len` bytes of data from the RandomInputable into an array of bytes. An attempt is made to read as many as `len` bytes, but a smaller number may be read. The number of bytes actually read is returned as an integer.

  This method is blocked until the input data is available, the end of the file is detected, or an exception is thrown.

  If the `len` is zero, then no bytes will be read and `0` will be returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at the end of the file, the value `-1` will be returned; otherwise, at least one byte will be read and stored into `b`.

  The first byte read is stored into element `b[off]`, the next one into `b[off+1]`, and so on. The number of bytes read is, at most, equal to `len`. Let k be the number of bytes actually read; these bytes will be stored in elements `b[off]` through `b[off+`k`-1]`, leaving elements `b[off+`k`]` through `b[off+len-1]` unaffected.

  In every case, elements `b[0]` through `b[off]` and elements `b[off+len]` through `b[b.length-1]` are unaffected.

  The `read(b,` `off,` `len)` method for class `RandomInputable` simply calls the method `read()` repeatedly. If the first call results in an `IOException`, that exception will be returned from the call to the `read(b,` `off,` `len)` method. If any subsequent call to `read()` results in an `IOException`, the exception will be caught and treated as if it were the end of the file; the bytes read up to that point are stored into `b` and the number of bytes read before the exception occurred is returned. The default implementation of this method is blocked until the requested amount of input data `len` is read, the end of the file is detected, or an exception is thrown. Subclasses are encouraged to provide a more efficient implementation of this method.

  Parameters:
    `b` - The buffer into which the data is read.
    `off` - The start offset in array `b` at which the data is written.
    `len` - The maximum number of bytes to be read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream is reached.
  Throws:
    `java.io.IOException` - if the first byte cannot be read for any reason other than reaching the end of the file, or if the input stream is closed, or if some other I/O error occurs.
    `java.lang.NullPointerException` - if `b` is `null`.
    `java.lang.IndexOutOfBoundsException` - if `off` is negative, `len` is negative, or `len` is greater than `b.length - off`.

### read

    int read(byte[] b)
             throws java.io.IOException

  Reads some number of bytes from the RandomInputable and stores them into the buffer array `b`. The number of bytes actually read is returned as an integer. This method is blocked until the input data is available, the end of the file is detected, or an exception is thrown.

  If the length of `b` is zero, then no bytes will be read and `0` will be returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at the end of the file, the value `-1` will be returned; otherwise, at least one byte will be read and stored into `b`.

  The first byte read is stored into element `b[0]`, the next one into `b[1]`, and so on. The number of bytes read is, at most, equal to the length of `b`. Let k be the number of bytes actually read; these bytes will be stored in elements `b[0]` through `b[`k`-1]`, leaving elements `b[`k`]` through `b[b.length-1]` unaffected.

  The `read(b)` method for class `RandomInputable` has the same effect as:

       read(b, 0, b.length) .

  Parameters:
    `b` - The buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream is reached.
  Throws:
    `java.io.IOException` - if the first byte cannot be read for any reason other than reaching the end of the file, or if the input stream is closed, or if some other I/O error occurs.
    `java.lang.NullPointerException` - if `b` is `null`.

### saveTo

    void saveTo(java.lang.String filename)
                throws java.io.IOException

  Saves all contents of RandomInputable into a destination file.

  Parameters:
    `filename` - Destination file string.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### skipBytes

    int skipBytes(int n)
                  throws java.io.IOException

  Attempts to skip over `n` bytes of the input, discarding the skipped bytes.

  This method may skip over some smaller number of bytes, possibly zero. This may result from any of a number of conditions; reaching the end of the file before `n` bytes is skipped is only one possibility. This method never throws an `EOFException`. The actual number of bytes skipped is returned. If `n` is negative, no bytes are skipped.

  Specified by:
    `skipBytes` in interface `java.io.DataInput`
  Specified by:
    `skipBytes` in interface `jet.util.RandomAccessable`
  Parameters:
    `n` - The number of bytes to be skipped.
  Returns:
    the actual number of bytes skipped.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD